@echo off
setlocal enabledelayedexpansion enableextensions
rem RENAME THIS FILE TO submit.bat and store it in the C:\CAMS directory.
rem
rem StageFromConfirmed.bat


:CHECKHELP
echo :CHECKHELP %*
	set bat_exedir=%~dp0::
	set bat_exedir=!bat_exedir:\::=!
	set bat_exedir=!bat_exedir:::=!

	set BAT_ECHOLOG=call :ECHOLOG
	set BAT_LOG=call :LOG
	set bat_logfile=!bat_exedir!\StageFromConfirmed.bat.log

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP

!bat_echolog! ==============================================================
!bat_echolog! [%date% %time%] %~nx0 %*
!bat_echolog!

	set bat_autonomous=
	echo.%*|find /i "autonomous">nul:
	if %errorlevel% equ 0 (
		set bat_autonomous=autonomous
		set bat_archivedfilesdir=%~1
		set bat_capturedfilesdir=%~2
		set bat_camera=%~3
	)

	if not defined bat_autonomous (
		!bat_echolog! Running in normal [non-autonomous] mode
	) else (
		!bat_echolog! Running in autonomous mode
	)


	!bat_echolog!
goto :SETUP

	
	
:SETUP
!bat_echolog! goto :SETUP %*
	set return=goto :EOF
	set bat_return=!return!
	
	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		!bat_echolog! '     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	call :PARSEARGS %*
	
	set bat_caldir=!bat_startlocation!\Cal
	set bat_validatefile=%~0.validate.log
	
	if not exist "!bat_mainspec!\!bat_getdirname!" (
		!bat_echolog! '     ERROR: specified source dir doesn't exist:^("!bat_mainspec!\!bat_getdirname!"^)
		exit /b 1
	) else (
		!bat_echolog! '     bat_mainspec=!bat_mainspec!
	)
	
	call :READPARAMS

goto :MAIN


:PARSEARGS 
echo call :PARSEARGS %*
	set bat_arg1=%~1
	set bat_getdirname=%~nx1
	set bat_mainspec=!bat_startlocation!\ArchivedFiles
	set bat_mainfilter=^|find /i "!bat_getdirname!"

	
	!bat_echolog! '     bat_autonomous=!bat_autonomous!

	if "!bat_arg1!" neq "" (
		if ":" equ "!bat_arg1:~1,1!" (
			!bat_echolog! '     Format 1: x:\CAMS\ArchivedFiles\datetime
			rem format is: x:\CAMS\ArchivedFiles\2011_08_15_00_00_00
			rem set bat_startdrive=!bat_arg1:~0,2!
			rem set bat_startlocation=!bat_startdrive!\CAMS
			set bat_mainspec=!bat_startlocation!\ArchivedFiles
			set bat_mainfilter=^|find /i "!bat_getdirname!"
		) else (
			rem look for 2011_08_15_00_00_00
			!bat_echolog! '     Scanning like this: %~1^|find /i /c "ArchivedFiles\"
			echo.%~1|find /i /c "ArchivedFiles\"
			set bat_returncode=!errorlevel!
			!bat_echolog! '     !bat_returncode!
			if !bat_returncode! equ 0 (
				!bat_echolog! '     Format 2: ArchivedFiles\!bat_getdirname!
				set bat_mainspec=!bat_startlocation!\ArchivedFiles
				set bat_mainfilter=^|find /i "!bat_getdirname!"
			) else (
				!bat_echolog! '     Format 3: 2011_08_15_00_00_00
				set bat_mainspec=!bat_startlocation!\ArchivedFiles
				set bat_mainfilter=|find /i /c "!bat_getdirname!"
			)
		)
	)
	
	set bat_dirname=!bat_getdirname!
	set bat_dirdate=!bat_dirname:~0,10!
	
!bat_echolog! return-:PARSEARGS: bat_dirname=!bat_dirname!, bat_mainspec=!bat_mainspec!, bat_mainfilter=!bat_mainfilter!
%return%


:MAIN
!bat_echolog! goto :MAIN %*
	rem start the execution of the detection pass in background priority
	set bat_returncode=0
	set bat_retval=success

	!bat_echolog! '     %date% %time%
	set bat_>>"!bat_logfile!"
	
	call :GETDIRNAMES "!bat_mainspec!"
	
	if "!bat_retval!" equ "success" (
		!bat_echolog! '     ---------------------------------------------------
		set bat_>>"!bat_logfile!"
		!bat_log!
		!bat_log! '    Done with %0 %*
		!bat_log!
		!bat_echolog! '    move /y "!bat_exedir!\*.log" "!bat_submitarchived!"
						   move /y "!bat_exedir!\*.log" "!bat_submitarchived!"
		set bat_returncode=0
	) else (
		set bat_returncode=1
	)
goto :DONE
:MAIN_END



:GETDIRNAMES
!bat_echolog! call :GETDIRNAMES [%*]
	rem Loop to iterate through all directory names under the ..\ArchivedFiles structure.
	echo     for /f "usebackq tokens=*" %%a in ^(`dir "!bat_mainspec!" /s/b /ad /on ^!bat_mainfilter! 2^>nul`^) do xxx
	for          /f "usebackq tokens=*" %%a in  (`dir "!bat_mainspec!" /s/b /ad /on ^!bat_mainfilter! 2^>nul`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					!bat_echolog! '     %%~a
					!bat_echolog! '


					set bat_archiveddirfull=%%a&		rem C:\CAMS\ArchivedFiles\2011_08_15_04_28_20
					set bat_dirname=%%~nxa&				rem 2011_08_15_04_28_20
					set bat_dirdate=!bat_dirname:~0,10!
					set bat_captureddate=!bat_dirdate!
					call :GETDETECTFILE "!bat_archiveddirfull!"
					if !bat_returncode! neq 0 (
						rem Can't exit early so comment out this:
						goto :GETDIRNAMES_END
					)
					
					set bat_detectfile1=!bat_archiveddirfull!\!bat_detectfile!

					if not defined bat_camera (
						call :GETCAMERAFROMDETECT "!bat_archiveddirfull!"
					)

					set bat_confirmeddirfull=!bat_archiveddirfull!
					set bat_confirmeddirfull=!bat_confirmeddirfull:ArchivedFiles=ConfirmedFiles!
					call :GETDETECTFILECONF "!bat_confirmeddirfull!"
					if not defined bat_detectfileconf (
						!bat_echolog! '    WARNING - No detect file found in "!bat_confirmeddirfull!"
						!bat_echolog! '              Continuing anyway..."!bat_detectfileconf!"
					)
					
					if not exist "!bat_confirmeddirfull!\!bat_detectfileconf!" (
						!bat_echolog! '    WARNING - No detect file found in "!bat_confirmeddirfull!". 
						!bat_echolog! '              Continuing anyway..."!bat_detectfileconf!"
						!bat_echolog!
					)


					rem Note: The date/time in the CapturedFiles directory will be different
					rem       than the date/time in the ArchivedFiles directory.  This is 
					rem       because the date/time of the CapturedFiles directory is 
					rem       the date/time when the directory was created, which is
					rem       several seconds before the end of the first 8 second video
					rem       section.  The date/time of the ConfirmedFiles and ArchivedFiles
					rem       directory is the date/time of the first file in the CapturedFiles
					rem       directory.
					set bat_yyyymmdd=!bat_dirname:~0,10!&	rem 2011_08_15
					set bat_captureddir=%bat_startlocation%\CapturedFiles\!bat_dirdate!&	rem C:\CAMS\CapturedFiles\2011_08_15
					if /i "!bat_capturedfilesdir!" neq "" (
						set bat_captureddir=!bat_capturedfilesdir!
					)

					set bat_submissiondir=%bat_startlocation%\SubmissionFiles\!bat_dirdate!\!bat_camera!&	rem C:\CAMS\SubmissionFiles\213\2011_08_15
					set bat_confirmeddirfull=%bat_startlocation%\ConfirmedFiles\!bat_dirname!&	rem C:\CAMS\ConfirmedFiles\2011_08_15_04_28_20
					set bat_emailfilesdir=!bat_submissiondir!\EmailFiles&						rem C:\CAMS\SuibmissionFiles\2011_08_15_04_28_20\EmailFiles

					set bat_submitarchived=!bat_submissiondir!\ArchivedFiles\!bat_dirname!&		rem C:\CAMS\SubmissionFiles\2011_08_15_04_28_20\ArchivedFiles\2011_08_15_04_28_20
					set bat_submitconfirmed=!bat_submissiondir!\ConfirmedFiles\!bat_dirname!&		rem C:\CAMS\SubmissionFiles\2011_08_15_04_28_20\ConfirmedFiles\2011_08_15_04_28_20
					set bat_submitcal=!bat_submissiondir!\Cal&		rem C:\CAMS\SubmissionFiles\2011_08_15_04_28_20\Cal
					set bat_submitcapturedbase=!bat_submissiondir!\CapturedFiles&		rem C:\CAMS\SubmissionFiles\2011_08_15_04_28_20\CapturedFiles

					if "!bat_dirname!" equ "" (
						set bat_retval=failed
						set bat_returncode=1
						!bat_echolog!
						!bat_echolog!
						!bat_echolog! '     ERROR - bat_dirname="!bat_dirname!"   ArchivedFiles dir="%%a"
						!bat_echolog!
						!bat_echolog!
					) else (
						call :CREATEDIRS "!bat_dirname!"
						call :MOVEFILES "!bat_dirname!"
						if "!bat_retval!" equ "failed" (
							set bat_returncode=1
							goto :GETDIRNAMES_END
						)
						call :READFILE
						if "!bat_retval!" equ "failed" (
							set bat_returncode=1
							goto :GETDIRNAMES_END
						)

						call :COPYCALFILE "!bat_calfilename!" "!bat_camera!"

						set bat_countconfirmed=0
						if exist "!bat_submitconfirmed!" (
							call :STRIPHEADER bat_countconfirmed "!bat_emailfilesdir!" "!bat_dirname!" "!bat_camera!" "confirmed" "!bat_confirmedmeteorcount!"
						)
						
						set bat_countarchived=0
						call :STRIPHEADER bat_countarchived  "!bat_emailfilesdir!" "!bat_dirname!" "!bat_camera!" "scanned" "!bat_archivedmeteorcount!"

						call :COUNTFILE !bat_countarchived! !bat_countconfirmed!

						!bat_echolog! '    move /y "!bat_submitarchived!\FTPdetectinfo.txt" "!bat_submitarchived!\FTPdetectinfo_0!bat_camera!_!bat_dirdate!.txt"
								           move /y "!bat_submitarchived!\FTPdetectinfo.txt" "!bat_submitarchived!\FTPdetectinfo_0!bat_camera!_!bat_dirdate!.txt"
						!bat_echolog! '    move /y "!bat_submitarchived!\FTPdetectinfo_0!bat_camera!_!bat_dirdate!.txt" "!bat_submitarchived!\FTPdetectinfo_0!bat_camera!_!bat_dirdate!.txt"
								           move /y "!bat_submitarchived!\FTPdetectinfo_0!bat_camera!_!bat_dirdate!.txt" "!bat_submitarchived!\FTPdetectinfo_0!bat_camera!_!bat_dirdate!.txt"

						!bat_echolog! '    move /y "!bat_submitconfirmed!\FTPdetectinfo.txt" "!bat_submitconfirmed!\FTPdetectinfo_0!bat_camera!_!bat_dirdate!.txt"
								           move /y "!bat_submitconfirmed!\FTPdetectinfo.txt" "!bat_submitconfirmed!\FTPdetectinfo_0!bat_camera!_!bat_dirdate!.txt"
						!bat_echolog! '    move /y "!bat_submitconfirmed!\FTPdetectinfo_0!bat_camera!_!bat_dirdate!.txt" "!bat_submitconfirmed!\FTPdetectinfo_0!bat_camera!_!bat_dirdate!.txt"
								           move /y "!bat_submitconfirmed!\FTPdetectinfo_0!bat_camera!_!bat_dirdate!.txt" "!bat_submitconfirmed!\FTPdetectinfo_0!bat_camera!_!bat_dirdate!.txt"


						!bat_echolog!
						!bat_echolog! call "!bat_exedir!\submit.email" "!bat_dirdate!" "!bat_camera!" !bat_autonomous!
									  call "!bat_exedir!\submit.email" "!bat_dirdate!" "!bat_camera!" !bat_autonomous!

						call :VALSUBMIT %*

					)& rem else
				)& rem if /i "%%~nxa" neq "gefdat"
			)& rem if /i "%%~nxa" neq "displayJPEGS"
		)& rem if /i "%%~nxa" neq "movies"
	)&	rem end of for /f %%a in ^(`dir "!bat_mainspec!" /s/b /ad /on ^!bat_mainfilter! 2^>nul`^)

:GETDIRNAMES_END
!bat_echolog! return-:GETDIRNAMES [!bat_retval!, bat_submissiondir=!bat_submissiondir!]
%return%



















































:VALSUBMIT 
!bat_echolog! call :VALSUBMIT %*
	set bat_retval=success
	rem This code block should be converted to a standalone batch script.

	!bat_echolog! ***************************** VALIDATION ********************************
	!bat_echolog! %date% %time%
	         echo %date% %time%>"!bat_validatefile!"

	set /a bat_valerrcount=0

	if /i "!bat_submissiondir!" equ "" (
		set /a bat_valerrcount+=1
		!bat_echolog! '     ERROR - bat_submissiondir="!bat_submissiondir!"
		         echo '     ERROR - bat_submissiondir="!bat_submissiondir!">>"!bat_validatefile!"

		!bat_echolog!
		!bat_echolog!
		echo.>>"!bat_validatefile!"
		echo.>>"!bat_validatefile!"
	) else (
		!bat_echolog! TREE /a "!bat_submissiondir!"
		         echo TREE /a "!bat_submissiondir!">>"!bat_validatefile!"
			          TREE /a "!bat_submissiondir!"
			          TREE /a "!bat_submissiondir!">>"!bat_logfile!"
			          TREE /a "!bat_submissiondir!">>"!bat_validatefile!"
		!bat_echolog!
		echo.>>"!bat_validatefile!"
	)

	!bat_echolog! TREE /a "%bat_startlocation%\Submitted\!bat_yyyymmdd!_!bat_camera!"
	         echo TREE /a "%bat_startlocation%\Submitted\!bat_yyyymmdd!_!bat_camera!">>"!bat_validatefile!"
	              TREE /a "%bat_startlocation%\Submitted\!bat_yyyymmdd!_!bat_camera!"
	              TREE /a "%bat_startlocation%\Submitted\!bat_yyyymmdd!_!bat_camera!">>"!bat_logfile!"
	              TREE /a "%bat_startlocation%\Submitted\!bat_yyyymmdd!_!bat_camera!">>"!bat_validatefile!"
	!bat_echolog!
	echo.>>"!bat_validatefile!"

	!bat_echolog! ' Validate EmailFiles\CAL-### dir
	         echo ' Validate EmailFiles\CAL-### dir>>"!bat_validatefile!"

	if not exist "!bat_emailfilesdir!\Cal-!bat_camera!\ff*.bin" (
		set /a bat_valerrcount+=1
		!bat_echolog! '   ERROR - missing "!bat_emailfilesdir!\Cal-!bat_camera!\ff*.bin"
		         echo '   ERROR - missing "!bat_emailfilesdir!\Cal-!bat_camera!\ff*.bin">>"!bat_validatefile!"
	)
	
	if not exist "!bat_emailfilesdir!\Cal-!bat_camera!\CAL!bat_camera!_*.txt" (
		set /a bat_valerrcount+=1
		!bat_echolog! '   ERROR - missing "!bat_emailfilesdir!\Cal-!bat_camera!\CAL!bat_camera!_*.txt"
		         echo '   ERROR - missing "!bat_emailfilesdir!\Cal-!bat_camera!\CAL!bat_camera!_*.txt">>"!bat_validatefile!"
	)

	if not exist "!bat_emailfilesdir!\Cal-!bat_camera!\CameraSites-!bat_camera!.txt" (
		set /a bat_valerrcount+=1
		!bat_echolog! '   ERROR - missing "!bat_emailfilesdir!\Cal-!bat_camera!\CameraSites-!bat_camera.txt"
		         echo '   ERROR - missing "!bat_emailfilesdir!\Cal-!bat_camera!\CameraSites-!bat_camera.txt">>"!bat_validatefile!"
	)

	!bat_echolog!
	echo.>>"!bat_validatefile!"

	!bat_echolog! ' Validate EmailFiles dir
	         echo ' Validate EmailFiles dir>>"!bat_validatefile!"

	set /a bat_counter=0
	for /f "usebackq tokens=*" %%a in (`dir "!bat_emailfilesdir!" /b /a-d /on`) do (
		set /a bat_counter+=1
		!bat_echolog! '     %%a
		         echo '     %%a>>"!bat_validatefile!"
	)
	!bat_echolog! '  Total files: !bat_counter!
	         echo '  Total files: !bat_counter!>>"!bat_validatefile!"

	if !bat_counter! LSS 7 (
		set /a bat_valerrcount+=1
		!bat_echolog! '   ERROR - Missing files from "!bat_emailfilesdir!". There should be
		!bat_echolog! '           a minimum of 7 files unless there is actually a ConfirmedFiles
		!bat_echolog! '           directory too, in which case there should be 10 or 11 files.
		!bat_echolog!
		
				 echo '   ERROR - Missing files from "!bat_emailfilesdir!". There should be>>"!bat_validatefile!"
				 echo '           a minimum of 7 files unless there is actually a ConfirmedFiles>>"!bat_validatefile!"
				 echo '           directory too, in which case there should be 10 or 11 files.>>"!bat_validatefile!"
				 echo.>>"!bat_validatefile!"
	)
	
	!bat_echolog!
	echo.>>"!bat_validatefile!"


	!bat_echolog! ' Validate Cal dir
	         echo ' Validate Cal dir>>"!bat_validatefile!"
	
	set /a bat_counter=0
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submitcal!" /b /a-d /on`) do (
		set /a bat_counter+=1
		!bat_echolog! '     %%a
		         echo '     %%a>>"!bat_validatefile!"
	)
	!bat_echolog! '   Total files: !bat_counter!
	         echo '   Total files: !bat_counter!>>"!bat_validatefile!"

	if !bat_counter! LSS 3 (
		set /a bat_valerrcount+=1
		!bat_echolog! '    ERROR - missing files from "!bat_submitcal!". There should be 3 files.
		         echo '    ERROR - missing files from "!bat_submitcal!". There should be 3 files.>>"!bat_validatefile!"
	)
	
	!bat_echolog!
	echo.>>"!bat_validatefile!"

	!bat_echolog! ' Validate Cal file^(s^) in "!bat_submitcal!"
	         echo ' Validate Cal file^(s^) in "!bat_submitcal!">>"!bat_validatefile!"

	set bat_temp=!bat_dirdate:~0,4!!bat_dirdate:~5,2!!bat_dirdate:~8,2!
	set /a bat_counter=0
	!bat_echolog! '    call "!bat_exedir!\ValidateCal.bat" /cal "!bat_submitcal!\CAL!bat_camera!_*.txt"
	         echo '    call "!bat_exedir!\ValidateCal.bat" /cal "!bat_submitcal!\CAL!bat_camera!_*.txt">>"!bat_validatefile!"
					   call "!bat_exedir!\ValidateCal.bat" /cal "!bat_submitcal!\CAL!bat_camera!_*.txt"
					   call "!bat_exedir!\ValidateCal.bat" /cal "!bat_submitcal!\CAL!bat_camera!_*.txt">>"!bat_logfile!"
	                   call "!bat_exedir!\ValidateCal.bat" /cal "!bat_submitcal!\CAL!bat_camera!_*.txt">>"!bat_validatefile!"
		
	!bat_echolog! .......................................................
	 echo.......................................................>>"!bat_validatefile!"
	
	!bat_echolog!
	echo.>>"!bat_validatefile!"
	!bat_echolog!
	echo.>>"!bat_validatefile!"

	set /a bat_counter=0
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submitarchived!" /s/b /a-d`) do (
		set /a bat_counter+=1
		title !bat_counter!
	)
	!bat_echolog! '  Validate "!bat_submitarchived!" dir  [Total files=!bat_counter!]
	         echo '  Validate "!bat_submitarchived!" dir  [Total files=!bat_counter!]>>"!bat_validatefile!"
	if !bat_counter! LSS 4 (
		set /a bat_valerrcount+=1
		!bat_echolog! '     ERROR - Missing files from "!bat_submitarchived!".
		         echo '     ERROR - Missing files from "!bat_submitarchived!".>>"!bat_validatefile!"
	)
		
	!bat_echolog!
	echo.>>"!bat_validatefile!"

	echo ' Validate "!bat_submitcapturedbase!" dir^(s^)...
	echo ' Validate "!bat_submitcapturedbase!" dir^(s^)...>>"!bat_logfile!"
	echo ' Validate "!bat_submitcapturedbase!" dir^(s^)...>>"!bat_validatefile!"

	set /a bat_counter=0
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submitcapturedbase!" /s/b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					!bat_echolog! '     "%%a"
					         echo '     "%%a">>"!bat_validatefile!"
				)
			)
		)
	)
	!bat_echolog!
	echo.>>"!bat_validatefile!"

	!bat_echolog! '   Total directories=!bat_counter!	in "!bat_submitcapturedbase!" dir  
	         echo '   Total directories=!bat_counter!	in "!bat_submitcapturedbase!" dir>>"!bat_validatefile!"

	if !bat_counter! LSS 1 (
		set /a bat_valerrcount+=1
		!bat_echolog! '     ERROR - Missing dir from "!bat_submitcapturedbase!".
		         echo '     ERROR - Missing dir from "!bat_submitcapturedbase!".>>"!bat_validatefile!"
	)

	set /a bat_counter=0
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submitcapturedbase!" /s/b /a-d`) do (
		set /a bat_counter+=1
	)
	!bat_echolog! '   Total files=!bat_counter!	in "!bat_submitcapturedbase!"
	         echo '   Total files=!bat_counter!	in "!bat_submitcapturedbase!">>"!bat_validatefile!"
	
	if !bat_counter! LSS 4 (
		set /a bat_valerrcount+=1
		!bat_echolog! '    ERROR - Missing files from "!bat_submitcapturedbase!".
		         echo '    ERROR - Missing files from "!bat_submitcapturedbase!".>>"!bat_validatefile!"
	)
	
	
	!bat_echolog!
	echo.>>"!bat_validatefile!"

	set /a bat_counter=0
	if exist "!bat_submitconfirmed!" (
		for /f "usebackq tokens=*" %%a in (`dir "!bat_submitconfirmed!" /s/b /a-d`) do (
			set /a bat_counter+=1
		)
	)
	!bat_echolog! '  Validate "!bat_submitconfirmed!" dir  [Total files=!bat_counter!]
	         echo '  Validate "!bat_submitconfirmed!" dir  [Total files=!bat_counter!]>>"!bat_validatefile!"

	if !bat_counter! LSS 1 (
		set /a bat_valerrcount+=1
		!bat_echolog! '    WARNING - Missing files from "!bat_submitconfirmed!".
		         echo '    WARNING - Missing files from "!bat_submitconfirmed!".>>"!bat_validatefile!"
	)
	
	!bat_echolog!
	!bat_echolog! '    Total validation errors: !bat_valerrcount!
	!bat_echolog!
	
	echo.>>"!bat_validatefile!"
	echo Total validation errors: !bat_valerrcount!>>"!bat_validatefile!"
	echo.>>"!bat_validatefile!"

	if defined autonomous (
		if /i "!bat_valerrcount!" neq "0" (
			rem If running in autonomous mode, don't continue..
			set bat_retval=failed
			set bat_returncode=1
			goto :VALSUBMIT_END
			rem exit /b 1
		)
	)
:VALSUBMIT_END
!bat_echolog! return-:VALSUBMIT: Total validation errors: !bat_valerrcount!
	!bat_echolog! waiting !bat_stage.validatewait! seconds
	start /w wait !bat_stage.validatewait!
%return%


	rem usage: call :CREATEDIRS "!bat_dirname!"
:CREATEDIRS
!bat_echolog! call :CREATEDIRS %*
	!bat_echolog! '     md "!bat_emailfilesdir!"
	if not exist "!bat_emailfilesdir!" (md "!bat_emailfilesdir!")
		     
	!bat_echolog! '     md "!bat_emailfilesdir!\Cal-!bat_camera!"
	if not exist "!bat_emailfilesdir!\Cal-!bat_camera!" (md "!bat_emailfilesdir!\Cal-!bat_camera!")

	!bat_echolog! '     md "!bat_submissiondir!\ArchivedFiles"
	if not exist "!bat_submissiondir!\ArchivedFiles" (md "!bat_submissiondir!\ArchivedFiles")
	     
	!bat_echolog! '     md "!bat_submissiondir!\ConfirmedFiles"
	if not exist "!bat_submissiondir!\ConfirmedFiles" (md "!bat_submissiondir!\ConfirmedFiles")
	     
	!bat_echolog! '     md "!bat_submitcal!"
	if not exist "!bat_submitcal!" (md "!bat_submitcal!")
	     
	!bat_echolog! '     md "!bat_submitcapturedbase!"
	if not exist "!bat_submitcapturedbase!" (md "!bat_submitcapturedbase!")
!bat_echolog! return-:CREATEDIRS
%return%



:GETCALFILENSTARS [in] "C:\CAMS\Cal\CAL299_20120101_015800_519.txt"
!bat_echolog! call :GETCALFILENSTARS [in] "C:\CAMS\Cal\CAL299_20120101_015800_519.txt"
	set /a bat_calfilestars=0
	for /f "usebackq tokens=1-3" %%h in (`find /i /c " " "%~1"`) do (
		set /a "bat_calfilestars=%%j-56"
	)
	!bat_echolog! '      Cal stars used: !bat_calfilestars!
%bat_return%





:MOVEFILES
!bat_echolog! call :MOVEFILES %*
	set bat_retval=success
	!bat_echolog! '    if not exist "!bat_detectfile1!" ^(
	if not exist "!bat_detectfile1!" (
		!bat_echolog!
		!bat_echolog! '    NOT FOUND: "!bat_detectfile1!"
		!bat_echolog!
		!bat_echolog! '    Sometimes you may fail to be able to have any scanned 
		!bat_echolog! '    meteors or tracks ^(e.g. completely overcast^). 
		!bat_echolog!
		if not defined bat_autonomous (
			set bat_choice=
			set /p bat_choice=   If that is the case, [C]ontinue, otherwise [Q]uit and fix the problem. 
			!bat_echolog!

			if /i "!bat_choice!" neq "c" (
				set bat_retval=failed
				!bat_echolog! '    [:MOVEFILES] FAILED - NOT FOUND: "!bat_archiveddirfull!\FTPdetectinfo*.txt">>"!bat_logfile!"
				goto :MOVEFILESEND
			)
		)
    )& rem if not exist "!bat_detectfile1!"...
    
    set bat_detectfileconf=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
    if not exist "!bat_confirmeddirfull!\!bat_detectfileconf!" (
    	set bat_detectinfoconf=FTPdetectinfo.txt
    )

	!bat_echolog! '    if not exist "!bat_confirmeddirfull!\!bat_detectfileconf!" ^(
	if not exist "!bat_confirmeddirfull!\!bat_detectfileconf!" (
		!bat_echolog!
		!bat_echolog! '    NOT FOUND: "!bat_confirmeddirfull!\!bat_detectfileconf!"
		!bat_echolog!
		!bat_echolog! '    Sometimes you may fail to be able to have any confirmed 
		!bat_echolog! '    meteors or tracks ^(e.g. completely overcast^). 
		!bat_echolog!
		if not defined bat_autonomous (
			set bat_choice=
			set /p bat_choice=   If that is the case, [C]ontinue, otherwise [Q]uit and fix the problem. 
			!bat_echolog!
			if /i "!bat_choice!" equ "q" (
				set bat_retval=failed
				goto :MOVEFILESEND
			)
			if /i "!bat_choice!" neq "c" (
				set bat_retval=failed
				!bat_echolog! '    [:MOVEFILES] FAILED - NOT FOUND: "!bat_confirmeddirfull!\!bat_detectfileconf!">>"!bat_logfile!"
				goto :MOVEFILESEND
			)
		)
		
		goto :MOVEFILES2
	)& rem if not exist "!bat_confirmeddirfull!\!bat_detectfileconf!"...
	
	!bat_echolog! '     copy /Y "!bat_confirmeddirfull!\!bat_detectfileconf!" "!bat_emailfilesdir!\FTPdetectinfo_confirmed-!bat_camera!.txt"
			            copy /Y "!bat_confirmeddirfull!\!bat_detectfileconf!" "!bat_emailfilesdir!\FTPdetectinfo_confirmed-!bat_camera!.txt"

	if not exist "!bat_emailfilesdir!\FTPdetectinfo_confirmed-!bat_camera!.txt" (
		!bat_echolog! '     Failed to copy
		set bat_retval=failed
		!bat_echolog! '    [:MOVEFILES] FAILED TO COPY "!bat_emailfilesdir!\FTPdetectinfo_confirmed-!bat_camera!.txt">>"!bat_logfile!"
		goto :MOVEFILESEND
	)

:MOVEFILES2
!bat_echolog! :MOVEFILES2
	if exist "!bat_confirmeddirfull!\comments_!bat_camera!.txt" (
		!bat_echolog! '    md "!bat_emailfilesdir!"
		                   md "!bat_emailfilesdir!"
		!bat_echolog! '     copy /Y "!bat_confirmeddirfull!\comments_!bat_camera!.txt" "!bat_emailfilesdir!"
				 			copy /Y "!bat_confirmeddirfull!\comments_!bat_camera!.txt" "!bat_emailfilesdir!"
				 
		if not exist "!bat_emailfilesdir!\comments_!bat_camera!.txt" (
			!bat_echolog! '     Failed to copy
			set bat_retval=failed
			!bat_echolog! '    [:MOVEFILES] FAILED TO COPY "!bat_emailfilesdir!\comments_!bat_camera!.txt">>"!bat_logfile!"
			goto :MOVEFILESEND
		)
	)
		  
	if exist "!bat_confirmeddirfull!" (
		!bat_echolog! '    move /Y "!bat_confirmeddirfull!" "!bat_submissiondir!\ConfirmedFiles"
						   move /Y "!bat_confirmeddirfull!" "!bat_submissiondir!\ConfirmedFiles"

		if !errorlevel! neq 0 (
			!bat_echolog! '     Failed to move
			set bat_retval=failed
			!bat_echolog! '     [:MOVEFILES] FAILED TO MOVE /Y "!bat_confirmeddirfull!" "!bat_submitconfirmed!"
			goto :MOVEFILESEND
		)

		if exist "!bat_confirmeddirfull!" (
			!bat_echolog! '     Failed to move
			set bat_retval=failed
			!bat_echolog! '     [:MOVEFILES] FAILED TO MOVE /Y "!bat_confirmeddirfull!" "!bat_submitconfirmed!"
			goto :MOVEFILESEND
		)
	)
	

	!bat_echolog! '    md "!bat_emailfilesdir!"
	                   md "!bat_emailfilesdir!"

    !bat_echolog! '    copy /Y "!bat_archiveddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_scanned-!bat_camera!.txt"
                       copy /Y "!bat_archiveddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_scanned-!bat_camera!.txt"
	!bat_echolog! '    copy /Y "!bat_archiveddirfull!\!bat_detectfile!" "!bat_emailfilesdir!\FTPdetectinfo_scanned-!bat_camera!.txt"
                       copy /Y "!bat_archiveddirfull!\!bat_detectfile!" "!bat_emailfilesdir!\FTPdetectinfo_scanned-!bat_camera!.txt"

    rem echo     copy /Y "!bat_archiveddirfull!\FTPdetectinfo.txt" "!bat_archiveddirfull!\FTPdetectinfo_0!bat_camera!_!bat_dirdate!.txt"
    rem          copy /Y "!bat_archiveddirfull!\FTPdetectinfo.txt" "!bat_archiveddirfull!\FTPdetectinfo_0!bat_camera!_!bat_dirdate!.txt"
   
    !bat_echolog! '    Packaged for submission on %date% %time%^>"!bat_emailfilesdir!\submit_!bat_camera!.txt"
                  echo Packaged for submission on %date% %time%>"!bat_emailfilesdir!\submit_!bat_camera!.txt"
    
	!bat_echolog! '    copy /Y /b "!bat_caldir!\CameraSites.txt" "!bat_emailfilesdir!"
	         		   copy /Y /b "!bat_caldir!\CameraSites.txt" "!bat_emailfilesdir!"

    !bat_echolog! '    copy /Y "!bat_archiveddirfull!\CameraTimeOffsets.txt" "!bat_emailfilesdir!"
             		   copy /Y "!bat_archiveddirfull!\CameraTimeOffsets.txt" "!bat_emailfilesdir!"

    !bat_echolog! '    copy /Y "!bat_archiveddirfull!\LASTSETTINGS.txt" "!bat_emailfilesdir!"
             		   copy /Y "!bat_archiveddirfull!\LASTSETTINGS.txt" "!bat_emailfilesdir!"

	!bat_echolog! '    copy /Y "!bat_archiveddirfull!\ReprocessParameters.txt" "!bat_emailfilesdir!"
	         		   copy /Y "!bat_archiveddirfull!\ReprocessParameters.txt" "!bat_emailfilesdir!"




	!bat_echolog! '    move /Y "!bat_archiveddirfull!" "!bat_submissiondir!\ArchivedFiles"
		     		   move /Y "!bat_archiveddirfull!" "!bat_submissiondir!\ArchivedFiles"

		if !errorlevel! neq 0 (
			!bat_echolog! '     Failed to move
			set bat_retval=failed
			!bat_echolog! '     [:MOVEFILES] FAILED TO MOVE /Y "!bat_archiveddirfull!" "!bat_submitconfirmed!"
			goto :MOVEFILESEND
		)


	if exist "!bat_archiveddirfull!" (
		!bat_echolog! '     Failed to move "!bat_archiveddirfull!" to "!bat_submitarchived!"
		set bat_retval=failed
		!bat_echolog! '     [:MOVEFILES] FAILED TO MOVE /Y "!bat_archiveddirfull!" to "!bat_submitarchived!"
		goto :MOVEFILESEND
	)
		  

	!bat_echolog! '    md "!bat_submitcapturedbase!"
	                   md "!bat_submitcapturedbase!"

	rem echo robocopy.exe "%%~dpnxb" "!bat_submitcapturedbase!\Captured\%%~nxb" /e /move
	rem  robocopy.exe "%%~dpnxb" "!bat_submitcapturedbase!\Captured\%%~nxb" /e /move
	for /f "usebackq tokens=*" %%b in (`dir "!bat_captureddir!*.*" /s/b /ad /on`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					rem echo md "!bat_submitcapturedbase!\%%~nxb"
					rem      md "!bat_submitcapturedbase!\%%~nxb"

					if exist "%%~dpnxb\FF!bat_camera!*.bin" (
						!bat_echolog! '     move /y "%%~dpnxb" "!bat_submitcapturedbase!"
											move /y "%%~dpnxb" "!bat_submitcapturedbase!"
						if exist "%%~dpnxb" (
							set bat_retval=failed
							!bat_echolog! '     Failed to move "%%~dpnxb" to "!bat_submitconfirmed!"
							!bat_echolog! '     [:MOVEFILES] FAILED TO MOVE /Y "!bat_archiveddirfull!" to "!bat_submitarchived!"
							if not defined bat_autonomous (
								set /p bat_choice=.  [C]ontinue or [Q]uit? 
								if /i "!bat_choice!" equ "q" (goto :MOVEFILESEND)
							)
						)
					)
				)
			)
		)
	)

	if /i "!bat_retval!" equ "failed" goto :MOVEFILESEND

:MOVEFILESEND
!bat_echolog! return-:MOVEFILES: 
%return%


	rem Loop to read the FTPdetectinfo.txt file.
	rem The goal is to extract from the detect file:
	rem  bat_ffdir, bat_caldir, bat_calfilename, bat_camera
:READFILE
!bat_echolog! call :READFILE "!bat_emailfilesdir!\FTPdetectinfo_scanned-!bat_camera!.txt", %*
	set bat_retval=success

	rem use the confirmed detect file if it exists because it is smaller. If
	rem it does not exist, then use the scanned detect file...
	set bat_readfile=!bat_emailfilesdir!\FTPdetectinfo_confirmed-!bat_camera!.txt
	
	if not exist "!bat_readfile!" (
		set bat_readfile=!bat_emailfilesdir!\FTPdetectinfo_scanned-!bat_camera!.txt
	)

	if not exist "!bat_readfile!" (
		!bat_echolog! '    [:READFILE] "!bat_readfile!" does not exist>>"!bat_logfile!"
		if not exist "!bat_readfile!" (
			!bat_echolog! '    ERROR cannot continue without an FTPdetectinfo file.
			!bat_echolog!
			!bat_echolog! '    The files have already been moved... you will need to move 
			!bat_echolog! '    them back and start over after resolving the problems.
			!bat_echolog!
			!bat_echolog! '    [:READFILE] ERROR - "!bat_readfile!" does not exist>>"!bat_logfile!"
			set bat_retval=failed
			goto :READFILE_END
		)
	)
	
	set bat_msg= 
	set /a bat_linecount=0
	set /a bat_filecount=0
	!bat_echolog! '    for /f "usebackq tokens=*" ..a in ^(`type "!bat_readfile!"`^) do ...
	for                    /f "usebackq tokens=*" %%a in  (`type "!bat_readfile!"`) do (
		set bat_temp=%%a
		set bat_temp=!bat_temp:~0,5!
		
		set /a bat_linecount+=1
		
		if !bat_linecount! equ 1 (
			call :GETMETEORCOUNT bat_countscanned %%a
		) else (
			if !bat_linecount! equ 5 (
				call :GETFFDIR "%%a"
			) else (
				if !bat_linecount! equ 6 (
					rem call :GETCALDIR "%%a"
				) else (
					if !bat_linecount! equ 13 (
						call :GETCAMERA
						set bat_fffilename=%%a
						!bat_echolog! '     bat_FFfilename="!bat_fffilename!"
						title !bat_fffilename!
					) else (
						if !bat_linecount! equ 14 (
							call :GETCALNAME "%%a"
							!bat_echolog! '     bat_calfilename="!bat_calfilename!"
						) else (
							if "!bat_temp!" equ "FF!bat_camera!" (
								set bat_fffilename=%%a
								title working on FF file: "!bat_fffilename!"
								set /a bat_filecount+=1
							)
						)
					)
				)
			)
		)
	)

	!bat_echolog! '     bat_fffilename=[!bat_fffilename!]

	if !bat_linecount! equ 0 (
		!bat_echolog!
		!bat_echolog! '    ERROR - Failed to process the detect file: !bat_readfile!
		!bat_echolog! '    them back and start over after resolving the problems.
		!bat_echolog!
		!bat_echolog! '    ABORTING
		!bat_echolog!
		!bat_echolog! '    ^(This program could do that in a future update^)
		!bat_echolog! '    [:READFILE] ERROR - ABORTING - Failed to process "!bat_readfile!">>"!bat_logfile!"
		set bat_retval=failed
	)

:READFILE_END
!bat_echolog! return-:READFILE [!bat_retval!]
%return%



:GETMETEORCOUNT
!bat_echolog! call :GETMETEORCOUNT %*
	rem Usage: call :GETMETEORCOUNT {return variable name} Meteor Count = 000533
	
	set bat_temp=%4
	if "!bat_temp!" equ "000000" (
		set bat_msg=; needs FTP_Reprocess
	)

	rem Strip leading zeros
	for /f "tokens=* delims=0" %%a in ("!bat_temp!") do (set %1=%%a)
	if not defined %1 set %1=0
!bat_echolog! return-:GETMETEORCOUNT: %* [!%1!]
%return%	


:GETEVENTCOUNT [in]detectfile [out]bat_retval
!bat_echolog! call :GETEVENTCOUNT [%*]
	set bat_tempfile=%~1
	set bat_retval=0

	if exist "!bat_tempfile!" (
		set /a bat_countdashes=0
	    !bat_echolog! '    for /f "usebackq tokens=3" ..X in ^(`find /i /c  ".bin" "!bat_tempfile!"`^) ...
		for                    /f "usebackq tokens=1-3 delims=: skip=1" %%X in  (`find /i /c  ".bin" "!bat_tempfile!"` ) do (
			if "%%X" neq "" (
				set bat_countdashes=%%Z
				set /a bat_countdashes=bat_countdashes+1-1
				title !bat_countdashes!
			)
		)

		set bat_countdashes=000000!bat_countdashes!
		set bat_countdashes=!bat_countdashes:~-6!
		!bat_echolog! '     Meteor Count = !bat_countdashes!
		title Meteor Count = !bat_countdashes!  "!bat_tempfile!" 
		set bat_retval=!bat_countdashes!
	) else (
		!bat_echolog! '     File not found - "!bat_tempfile!"
		set bat_retval=-1
	)
!bat_echolog! return-:GETEVENTCOUNT [!bat_retval!]
%return%


:STRIPHEADER
!bat_echolog! call :STRIPHEADER %*
	rem Usage: call STRIPHEADER bat_variable sourcefile targetfile
	rem Copy the ".\ConfirmedFiles\[date/time]\FTPdetectinfo.txt file to 
	rem "[date/time]\EmailFiles\FTPdetectinfo_confirmed-[bat_camera]-[meteor count].txt" 
	rem with the header stripped from it.
	
	echo     Stripping header to: "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
	
	set bat_sourcefile=%~5
	
	set /a bat_countscan=0
	set /a bat_countevent=0
	
	set /a bat_remain=0
	TITLE :STRIPHEADER %* !%1!-!bat_countevent!=!bat_remain!  %%d
	
	set bat_tempsource=!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!.txt
	set bat_tempheader=!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!_header.txt
	set bat_tempstripped=!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-%~6.txt
	
	!bat_echolog! '    call "!bat_exedir!\StripHeaderVBS.bat" "!bat_tempsource!" "!bat_tempheader!" "!bat_tempstripped!"
	                   call "!bat_exedir!\StripHeaderVBS.bat" "!bat_tempsource!" "!bat_tempheader!" "!bat_tempstripped!"
	GOTO :STRIPHEADER_END

							call :GETEVENTCOUNT "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!.txt"

							echo     for /f "usebackq tokens=*" %%d in (`type "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!.txt"`)
							echo     This step may take along time, please be patient...
							for /f "usebackq tokens=*" %%d in (`type "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!.txt"`) do (
								set bat_linebuf=%%d
								set /a bat_countscan+=1
								if "!bat_countscan!" equ "1" (
									call :GETMETEORCOUNT  %1 %%~d
									if exist "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt" (
										del "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
									)
									TITLE :STRIPHEADER %* !%1!-!bat_countevent!=!bat_remain!  %%d
								) else (
									if !bat_countscan! GTR 11 (
										echo %%d>>"!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
										if /i "!bat_linebuf:~0,6!" equ "FF!bat_camera!_" (
											set /a bat_countevent+=1
											set /a bat_remain=!%1!-!bat_countevent!
											TITLE :STRIPHEADER %* !%1!-!bat_countevent!=!bat_remain!  %%d
										)
									)
								)
							)
:STRIPHEADER_END
!bat_echolog! return-:STRIPHEADER
%return%


:GETFFDIR
!bat_echolog!  call :GETFFDIR %*
	rem Usage: call :GETFFDIR "FF  folder = c:\CAMS\ArchivedFiles\2011_08_05_04_40_44\"
	rem Called when reaing FTPdetectinfo.txt line 5 to fetch the FF folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d
		set bat_ffdir=!bat_temp2:C:=%bat_startdrive%!
	)
!bat_echolog!  return-:GETFFDIR %*  [!bat_ffdir!]
%return%


:GETCALDIR
!bat_echolog!  call :GETCALDIR %*
	rem Usage: call :GETCALDIR "CAL folder = c:\CAMS\Cal\"
	rem Called when reaing FTPdetectinfo.txt line 6 to fetch the Cal folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d
		set bat_caldir=!bat_temp2:C:=%bat_startdrive%!
	)
!bat_echolog!  return-:GETCALDIR %*  [!bat_caldir!]
%return%


:GETCAMERA
!bat_echolog! call :GETCAMERA %*
	set bat_camera=!bat_temp:~2,3!
!bat_echolog! return-:GETCAMERA: [%*]  [!bat_camera!]
%return%


:GETCALNAME
!bat_echolog!  call :GETCALNAME %*
	rem 
	set bat_calfilename=%~1
!bat_echolog!  return-:GETCALNAME %*  [!bat_calfilename!]
%return%



:COUNTFILE
!bat_echolog! call :COUNTFILE %1 %2
	rem Create a file that has the meteorcounts
	set bat_countfile=!bat_emailfilesdir!\!bat_camera!_archived=%1, confirmed=%2.txt

	set bat_temp1=0
	set bat_temp2=0

	if /i "%~1" neq "" (
		set bat_temp1=%~1
	)

	if /i "%~2" neq "" (
		set bat_temp2=%~2
	)

	!bat_echolog! '     Meteor Counts:  Archived="!bat_temp1!"   Confirmed="!bat_temp2!"
	           echo     Meteor Counts:  Archived="!bat_temp1!"   Confirmed="!bat_temp2!">"!bat_countfile!"

	!bat_echolog! '     copy /y /b "!bat_countfile!" + "!bat_emailfilesdir!\comments_!bat_camera!.txt" "!bat_countfile!"
	                    copy /y /b "!bat_countfile!" + "!bat_emailfilesdir!\comments_!bat_camera!.txt" "!bat_countfile!"
	
	echo.>>"!bat_countfile!"

	!bat_echolog! '     type "!bat_countfile!"
	                    type "!bat_countfile!">>"!bat_logfile!"
	                    type "!bat_countfile!"
	!bat_echolog! '     call "%~dp0CheckTwilight.bat" !bat_dirname:~5,2!/!bat_dirname:~8,2!/!bat_dirname:~0,4!}}"!bat_countfile!"
	                    call "%~dp0CheckTwilight.bat" !bat_dirname:~5,2!/!bat_dirname:~8,2!/!bat_dirname:~0,4!>>"!bat_countfile!"
!bat_echolog! return-:COUNTFILE: [!bat_countfile!]
%return%



:COPYCALFILE
!bat_echolog! call :COPYCALFILE %*
	if not exist "!bat_emailfilesdir!\Cal-!bat_camera!" (
		!bat_echolog! '    md "!bat_emailfilesdir!\Cal-!bat_camera!"
		                   md "!bat_emailfilesdir!\Cal-!bat_camera!"
	)

	!bat_echolog! '    md "!bat_submitcal!"
	                   md "!bat_submitcal!"
	
	!bat_echolog! '     copy /Y /b "!bat_caldir!\CameraSites.txt" "!bat_submitcal!"
	                    copy /Y /b "!bat_caldir!\CameraSites.txt" "!bat_submitcal!"

	!bat_echolog! '     copy /Y /b "!bat_caldir!\CameraSites-!bat_camera!.txt" "!bat_emailfilesdir!\Cal-!bat_camera!"
	                    copy /Y /b "!bat_caldir!\CameraSites-!bat_camera!.txt" "!bat_emailfilesdir!\Cal-!bat_camera!"

	!bat_ecohlog! '     copy /Y /b "!bat_caldir!\CameraSites-!bat_camera!.txt" "!bat_submitcal!"
	                    copy /Y /b "!bat_caldir!\CameraSites-!bat_camera!.txt" "!bat_submitcal!"

	if defined bat_calfilename (
		!bat_ecohlog! '     copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_emailfilesdir!\Cal-!bat_camera!"
		                    copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_emailfilesdir!\Cal-!bat_camera!"

		!bat_echolog! '     copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_submitcal!"
		                    copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_submitcal!"

		call :COPYCALFF "!bat_calfilename!"
	)
	

!bat_echolog! return-:COPYCALFILE: "bat_calfilename=!bat_calfilename!"
%return%


		rem read the cal file and use the date on line 2 and the time on 
		rem line 3 to create a search for the cal file.  To use the following
		rem example, the search will search in reverse order for the ff*.bin
		rem files from the CapturedFiles directory.
		rem Here is the format of the cal file
	1	 Camera number            = 213
	2	 Calibration date         = 08/18/2011
	3	 Calibration time (UT)    = 03:38:09.187
		rem
		rem IMPROVEMENTS NEEDED:
		rem   1) We need to figure out a way to be able to use an FF file
		rem   from a previous date in order to handle those cases where the
		rem   calibration for the current night was not possible.
		rem   ANSWER) Copy the FF file to the cal dir.
		rem
		rem   2) Performance - improve by creating a file containing a listing
		rem      of all the FF files. Then compare that. It should be faster.
:COPYCALFF [in] "!bat_calfilename!"
!bat_echolog! call :COPYCALFF %*

	set /a bat_calff_line=0
	if defined bat_calfilename (
		if not exist "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!" (
			!bat_echolog! '    File Not Found: "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!"
			if not defined bat_autonomous (
				pause
			)
		)
		
		
		rem This first loop obtains the date/time from within the cal file in
		rem preparation for the second loop, which uses that date/time to iterate
		rem backward through the capturedfiles dir looking for the FF file
		rem that immediately preceeds this date/time.
		!bat_echolog! '    for /f "usebackq skip=2 tokens=1-5" ..f in ^(`find /i "Calibration " "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!"`^) do ...
		for                    /f "usebackq skip=2 tokens=1-5" %%f in  (`find /i "Calibration " "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!"`) do (
			set /a bat_calff_line+=1
			title Reading "!bat_calfilename!" for date/time of FF file used for calibration: [!bat_calff_line!: %%f %%g %%h %%i %%j]
			if !bat_calff_line! equ 1 (
				rem date
				rem echo %%f, %%g, %%h, %%i, %%j
				set bat_calffdate=%%i
				set bat_calffyyyy=!bat_calffdate:~-4!
				set bat_calffmm=!bat_calffdate:~0,2!
				set bat_calffdd=!bat_calffdate:~3,2!
			) else (
				if !bat_calff_line! equ 2 (
					rem time
					rem echo %%f, %%g, %%h, %%i, %%j
					set bat_calfftime=%%j
					set bat_calffhh=!bat_calfftime:~0,2!
					set bat_calffm=!bat_calfftime:~3,2!
					set bat_calffss=!bat_calfftime:~6,2!
				) else (
					rem ignore 
				)
			)
		)

		set bat_filespec=!bat_calffhh!!bat_calffm!!bat_calffss!
		set bat_searchspec=FF!bat_camera!_!bat_calffyyyy!!bat_calffmm!!bat_calffdd!_

		rem This loop iterates backward through the CapturedFiles directory and
		rem looks for a file that immediately preceeds the Cal file's date/time.
		set bat_calff_found=0
		!bat_echolog! '    for /f "usebackq tokens=*" ..f in ^(`dir "!bat_submitcapturedbase!\!bat_searchspec!*.bin" /s/b /a-d /o-n`^) do 
		for                    /f "usebackq tokens=*" %%f in  (`dir "!bat_submitcapturedbase!\!bat_searchspec!*.bin" /s/b /a-d /o-n`) do (
			rem
			set bat_tempfilefull=%%f
			set bat_tempfilename=%%~nxf
			set bat_tempyyyy=!bat_tempfilename:~6,4!
			set bat_tempmm=!bat_tempfilename:~10,2!
			set bat_tempdd=!bat_tempfilename:~12,2!
			set bat_temphh=!bat_tempfilename:~15,2!
			set bat_tempmin=!bat_tempfilename:~17,2!
			set bat_tempsec=!bat_tempfilename:~19,2!

			set bat_tempspec=!bat_temphh!!bat_tempmin!!bat_tempsec!

			title Scanning "!bat_submitcapturedbase!" for FF file used in "!bat_calfilename!": %%f

			if !bat_calff_found! equ 0 (
				if !bat_tempspec! lss !bat_filespec! (
					set bat_calff_found=!bat_tempfilefull!
					set bat_calffname=!bat_tempfilefull!
					!bat_echolog! '                                   FOUND "!bat_calff_found!"
					!bat_echolog! '     copy /Y /b "!bat_calffname!" "!bat_emailfilesdir!\Cal-!bat_camera!"
					                    copy /Y /b "!bat_calffname!" "!bat_emailfilesdir!\Cal-!bat_camera!"

					if not exist "!bat_caldir!\BinFiles" (
						!bat_echolog! '     md "!bat_caldir!\BinFiles"
						                    md "!bat_caldir!\BinFiles"
					)

					!bat_echolog! '     copy /Y /b "!bat_calffname!" "!bat_caldir!\BinFiles"
					                    copy /Y /b "!bat_calffname!" "!bat_caldir!\BinFiles"
				) else (
					rem echo NOT FOUND
					rem set bat_
					rem pause
				)
			)
		)
		
		rem if cant find the ff file in capturedfiles, find it in Cal\BinFiles
		if /i "!bat_calff_found!" equ 0 (
			set bat_tempspec=CAL!bat_camera!_!bat_tempspec!
			set bat_calff_found=0
			for /f "usebackq tokens=*" %%f in (`dir "!bat_caldir\BinFiles\!bat_searchspec!*.bin" /b /a-d /on`) do (
				set bat_tempfilefull=!bat_caldir\BinFiles\%%~f
				set bat_tempfilename=%%~nxf
				
				set bat_calff_found=!bat_tempfilefull!
				set bat_calffname=!bat_tempfilefull!
				!bat_echolog! '                     FOUND "!bat_calff_found!"
				!bat_echolog! '    copy /Y /b "!bat_calffname!" "!bat_emailfilesdir!\Cal-!bat_camera!"
			                       copy /Y /b "!bat_calffname!" "!bat_emailfilesdir!\Cal-!bat_camera!"
			)
		)
	) else (
		!bat_echolog! '    ERROR - bat_calfilename=[]
	)

:COPYCALFF_END
!bat_echolog! return-:COPYCALFF: Cal File FF name for "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!"  ["!bat_calffname!"]
%return%



:GETCAMERAFROMDETECT
echo call :GETCAMERAFROMDETECT [%*]
	set bat_detectfile2=%~1\!bat_detectfile!
	set bat_detectfile1=!bat_detectfile2!

	if not defined bat_camera (
		rem Try FTPdetectinfoC.txt
		if exist "%~1\FTPdetectinfoC.txt" (	
			                set bat_detectfile1=%~1\FTPdetectinfoC.txt
			!bat_echolog! '     bat_detectfile1=!bat_detectfile1!
			move /y "!bat_detectfile2!" "FTPdetectinfo.bak.txt"
			copy /y "!bat_detectfile1!" "!bat_detectfile2!"
		) else (
			if exist "%~1\FTPdetectinfo_????_????_??_??.txt" ( 
				rem Try FTPdetectinfo_###_yyyy_mm_dd.txt
				!bat_echolog! '     if exist "%~1\FTPdetectinfo_????_????_??_??.txt"
				for /f "usebackq tokens=*" %%b in (`dir "%~1\FTPdetectinfo_????_????_??_??.txt" /a-d /s/b`) do (
					set bat_detectfile1=%%~dpnxb
				)
				move /y "!bat_detectfile2!" "FTPdetectinfo.bak.txt"
				move /y "!bat_detectfile1!" "!bat_detectfile2!"
			) else (
				set bat_detectfile1=!bat_detectfile2!
				!bat_echolog! '     bat_detectfile1=!bat_detectfile1!
			)
		)

		find /i ".bin" "!bat_detectfile2!"
		if !errorlevel! equ 0 (
			!bat_echolog! '    WARNING - Can't ascertain camera from "!bat_detectfile2!"
		) else (
			for /f "usebackq skip=2 tokens=*" %%b in (`find /i ".bin" "!bat_detectfile2!"`) do (
				set bat_camera=%%b
				set bat_camera=!bat_camera:~2,3!
			)
		)

		if "!bat_camera!" equ "" (
			!bat_echolog! '     Trying to find it from "%~1\FFCorruptFilesLog_Case*.txt"
			for /f "usebackq tokens=*" %%b in (`find /i "is the reference" "%~1\FFCorruptFilesLog_Case*.txt"`) do (
			   set bat_camera=%%b
			   set bat_camera=!bat_camera:~2,3!
			   !bat_echolog! '     camera=!bat_camera!
			)
		)

		echo :GETCAMERAFROMDETECT-return [%*]   [camera=!bat_camera!] [!bat_detectfile1!]
		if "!bat_camera!" equ "" (
			!bat_echolog! '     ERROR: couldn't determine camera number
			set /p bat_camera=ENTER THE CAMERA NUMBER: 
		)
	)

:GETCAMERAFROMDETECT_END
!bat_echolog! return-GETCAMERAFROMDETECT: [camera=!bat_camera!, detectfile1=!bat_detectfile1!, detectilfe2=!bat_detectfile2!]
%return%



:GETDETECTFILE [in] bat_archiveddirfull
!bat_echolog! call :GETDETECTFILE %*
	set bat_detectfile=
	if /i "!bat_archivedfilesdir!" equ "" (
		set bat_returncode=1
		set bat_retval=failed
		goto :GETDETECTFILE_END
	)

	set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt

	if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
		set bat_detectfile=FTPdetectinfo.txt

		if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
			set bat_detectfile=
			!bat_echolog! '    ERROR - No detect file found "!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt"
			set bat_returncode=1
			set bat_retval=failed
			goto :GETDETECTFILE_END
		)
	)
	
:GETDETECTFILE_END
!bat_echolog! return-:GETDETECTFILE_END [bat_detectfile=!bat_detectfile!]
%return%




:GETDETECTFILECONF [in] bat_confirmeddirfull
!bat_echolog! call :GETDETECTFILECONF %*
	set bat_detectfileconf=
	if /i "!bat_confirmeddirfull!" equ "" (
		goto :GETDETECTFILECONF_END
	)

	set bat_detectfileconf=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt

	if not exist "!bat_confirmeddirfull!\!bat_detectfileconf!" (
		set bat_detectfileconf=FTPdetectinfo.txt

		if not exist "!bat_confirmeddirfull!\!bat_detectfileconf!" (
			set bat_detectfileconf=
			!bat_echolog! '    NOT FOUND - FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
			goto :GETDETECTFILECONF_END
		)
	)
	
:GETDETECTFILECONF_END
!bat_echolog! return-:GETDETECTFILECONF_END [bat_detectfileconf=!bat_detectfileconf!]
%return%






:READPARAMS
!bat_log! call "!bat_exedir!\ReadParams.bat"
	      CALL "!bat_exedir!\ReadParams.bat"
:READPARAMS_END
!bat_log! return-:READPARAMS [!bat_paramsfile!=!bat_retval!]
%bat_return%








:ECHOLOG
	rem Echo to the console and to the bat_logfile
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*
	
	rem set bat_echolog_temp=%bat_echolog_temp:~1,3000%

	echo %bat_echolog_temp%>>"!bat_logfile!"
	echo %bat_echolog_temp%
%bat_return%


:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		%bat_return%
	)

	set bat_echolog_temp=%*
	
	rem set bat_echolog_temp=%bat_echolog_temp:~1,3000%

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%



	Flowchart:
		- Obtain the processed ".\ConfirmedFiles\<dirname>"
		- Create the target ".\SubmissionFiles\<dirname>" directory tree:
		  - EmailFiles
		  - BinFiles
		  - AviFiles
		- Copy the ".\ArchivedFiles\<dirname>\FTPdetectinfo.txt" file and change name to
		  ".\SubmissionFiles\<dirname>\FTPdetectinfo_<camera>_<dirname>_scanned-!bat_camera!.txt"
		- Copy the ".\ConfirmedFiles\<dirname>\FTPdetectinfo.txt" file and change name to
		  ".\SubmissionFiles\<dirname>\FTPdetectinfo_<camera>_<dirname>_confirmed.txt"
		- Copy the ".\ArchivedFiles\<dirname>\CameraTimeOffsets.txt" file 

		- Move the ".\ConfirmedFiles\<dirname>\*.bin" files to 
		  the ".\SubmissionFiles\<dirname>\BinFiles" directory.
		- Read the ".\SubmissionFiles\<dirname>\ftpdetectinfo.txt" file and 
		  get the following:
			- Meteor Count     from line number 1
			- FF  folder       from line number 5
			- CAL folder       from line number 6
			- calibration file from line number 14
			- camera number    from calibration file
	==============================================================		
	New changes 12/20/2011:
		(1) Fixed bugs
		
		(2) Added :VALSUBMIT.  This code block validates all the target
		    directories and files that are supposed to be the result of 
		    a successful submission run.  There are still a few areas that
		    can be validate more thoroughly, namely, the calibration files.

	New changes 09/21/2011:
		(1) Change thesae changes are to make it easier to restore the files to the 
		x:\CAMS basedir where they can be reprocessed by placing the files in a 
		subdir tree structure under .\SubmissionFiles\[date] that matches the source
		tree structure.
		
		(2) Copy the FF213_20110815_050001_207_0034816.bin type file that was the one used
		for calibration into the ".\SubmissionFiles\[date]\EmailFiles\Cal-213" directory.
		
		(3) 
		
	Note: All the examples will use the following sample names based on 08/15/2011 data:
	   C:\CAMS\ArchivedFiles\2011_08_15_04_28_20
	   C:\CAMS\ArchivedFiles\2011_08_15_04_28_20\*.txt (ftpdetectinfo.txt, etc.)
	   C:\CAMS\CapturedFiles\2011_08_15_04_28_20
	   C:\CAMS\CapturedFiles\2011_08_15_04_28_20\FF213_20110815_050006_172_0057344.bin (calibration file)
	   C:\CAMS\ConfirmedFiles\2011_08_15_04_28_20

	New changes 09/08/2011:
		x Add a " [date/time]\EmailFiles\Cal-[camera]" directory and place the calibration files there.  (I obtain the calibration filename by actually reading the ftpdetectinfo.txt file and then copying the filename from the Cal directory). 
		
		x Copy the ".\Cal\[calfile date/time] to "[date/time]\EmailFiles\Cal-[camera]" but don't change the filename.
		
		x Copy the ".\Cal\CameraSites.txt" file to "[date/time]\EmailFiles\Cal-[camera]" and rename it to "CameraSites-[camera].txt"
		
		x Copy the ".\ConfirmedFiles\[date/time]\FTPdetectinfo.txt file to "[date/time]\EmailFiles\FTPdetectinfo_confirmed-[camera]-[meteor count].txt" with the header stripped from it.
		
		x Copy the ".\ArchivedFiles\[date/time]\FTPdetectinfo.txt" file to "[date/time]\EmailFiles\FTPdetectinfo_scanned-[camera]-[meteor count].txt" with the header stripped from it.
		
		x I think that I will also add a file with a name to reflect the meteor count "archived=[count], confirmed=[count].txt" to make it easier to see
		
		- Copy the comments.txt file
		
	Needed changes 02/07/2012:
		- Fix GETCAMERAFROMDETECT so it works if meteorcount is zero.
		- Fix COPYCALFF so it works if meteorcount is zero
		- Fix COPYCALFF so it stops copying the entire cal directory.
		- Test using 02/07/2012 data for no detections. 

	rem    





:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 ^<datetimedir^>
	echo.
	echo Examples: 
	echo        %~nx0 2011_08_01_05_00_19
	echo        %~nx0 ArchivedFiles\2011_08_01_05_00_19
	echo        %~nx0 C:\CAMS\ArchivedFiles\2011_08_01_05_00_19
	echo.
	echo This script can be run stand-alone (before reprocessing) or called from within
	echo a script.
	echo.
	echo The purpose of this script is to stage the collection of files that can be
	echo transmitted to the coordinator.  The transmissions need to be broken
	echo down into two different collections for the following purposes: 
	echo 	(1) Email the text files to him in a timely manner
	echo 	(2) Mail a DVD archive of the FF*.bin files along with the text files
	echo.
	echo The organization of these files needs to be as follows (with the first first
	echo four containing the original files that match the date:
	echo    .\CAMS\SubmissionFiles\2011_08_01_05_00_19\213\ArchivedFiles
	echo    .\CAMS\SubmissionFiles\2011_08_01_05_00_19\213\Cal
	echo    .\CAMS\SubmissionFiles\2011_08_01_05_00_19\213\CapturedFiles
	echo    .\CAMS\SubmissionFiles\2011_08_01_05_00_19\213\ConfirmedFiles
	echo.
	echo    .\CAMS\SubmissionFiles\2011_08_01_05_00_19\213\EmailFiles       contains:
	echo        - !bat_camera!_archived=56, confirmed=6.txt
	echo                            Contains meteor counts for archived and confirmed, 
	echo                            as well as the contents of the comments_!bat_camera!.txt file.
	echo.
	echo        - CameraSites.txt               From the Cal dir
	echo        - CameraTimeOffsets.txt         From ArchivedFiles
	echo        - comments.txt                  Comments file from the user from ConfirmedFiles dir.
	echo.
	echo        - FTPdetectinfo_confirmed-!bat_camera!.txt
	echo                            renamed from FTPdetectinfo.txt from the 
	echo                            \cams\ConfirmedFiles directory.
	echo                            Also, it should be patched to reflect where  
	echo                            the ff*.bin files are, relative from the 
	echo                            current dir
	echo.
	echo        - FTPdetectinfo_confirmed-213-6.txt
	echo                            Same as FTPdetecinfo_confirmed-!bat_camera!.txt but it has
	echo                            the headers stripped out to make it easier to
	echo                            concatenate.  The numbers are the camera and meteor count.
	echo.
	echo        - FTPdetectinfo_scanned-!bat_camera!.txt
	echo                            Same idea as the FTPdetectinfo_confirmed-!bat_camera!.txt file
	echo                            except that this one comes from the ArchivedFiles
	echo                            directory
	echo.
	echo        - FTPdetectinfo_scanned-213-56.txt
	echo                            Same as for the confirmed file except that this
	echo                            one has the meteor count the ArchivedFiles.
	echo.
	echo        - LASTSETTINGS.txt               From ArchivedFiles
	echo        - ReprocessParameters.txt        From ArchivedFiles
	echo        - submit_!bat_camera!.txt        File containing date of this procedure
	echo.
	echo        ..\EmailFiles\Cal-213
	echo            - CAL213_20110801_050019_514.txt
	echo            - CameraSites-213.txt
	echo            - FF213_20110801_050001_960_0023296.bin  (bin file used for calibration)
	echo.				 
	echo After the script verifies the movement of all these files, the user is ready to create a
	echo zip file of everything in the ".\Submitted\<datetime>_<camera>\EmailFiles" so that 
	echo they can be sent via email.  Running "submit.email.bat" will take care of copying
	echo the files to the .\Submit dir.  From there, you can create a zip file of the dirs
	echo that you haven't yet submitted.
	echo.
	echo Most of this can be automated in a script in batch mode. We can't make a 
	echo DVD unattended though and that will need to be done manually.
	echo.
	echo To make the DVD, we copy ".\cams\SubmissionFiles\*.*" to the DVD burner.
	echo It might work better with RoboCopy, since I think it might support filling
	echo up a DVD and then continuing, but I'm not quite sure.
	echo.
	echo Once the DVD is burned, the files should be MOVED to ".\cams\SubmittedFiles\..." 
	echo.
	echo After a period of time, the specific ".\cams\SubmittedFiles\<datetime> directories can 
	echo be purged from the hard drive to make room for newer files. 
	echo.
	echo Ideally, all this should run from a copy on an external hard drive 
	echo so it can be processed on another computer and it won't interfere with capture, etc.
	echo.
	echo One issue to resolve is when there is an ArchivedFiles\^<date/time^> directory but no 
	echo matching ConfirmedFiles^<date/time^> directory.  This could have been caused by
	echo not being able to complete the processing due to some bug or corrupt files.  In that
	echo case, we just submit the files from the ArchivedFiles\^<date/time^> directory and 
	echo notate that in the readme.txt file in the directory.  Another cause is that
	echo the night was completely clouded out so there is nothing to confirm.  In such a case,
	echo we could require that a comments.txt file and/or an FTPdetectinfo.txt file with
	echo a meteor count = 000000 is created.
	echo.
	echo Also, we need to start copying the necessary CAL and other files into the ArchivedFiles 
	echo directory as part of the ftp_reprocess.bat steps.  Perhaps we do that by calling
	echo a "complete_reprocessing.bat" routine.  Such a routine should be able to be run at
	echo anytime after FTP_Reprocess.exe is completed (or even while it is running).  The reason 
	echo for this is to keep a copy of the associated cal files and keep them with the
	echo set. 
	echo.
	echo Samples: 
	echo        %~nx0 2011_08_01_05_00_19
	echo        %~nx0 ArchivedFiles\2011_08_01_05_00_19
	echo        %~nx0 C:\CAMS\ArchivedFiles\2011_08_01_05_00_19
	echo.
	echo  Also:
	echo        "%~nx0 %~nx0 C:\CAMS\ArchivedFiles\2011_08_01_05_00_19" "%~nx0 C:\CAMS\ArchivedFiles\2011_08_01_05_00_19" 299 autonomous
exit /b 9


:DONE
	echo.
	echo Done with %0 %*
	echo.
	if "!bat_retval!" equ "success" (set bat_retval=0) else (set bat_retval=1)
exit /b !bat_returncode!