  @echo off
setlocal enabledelayedexpansion enableextensions
rem MakeArchiveDateZip.bat
rem This script is supposed to zip a directory using seven zip.

:CHECKHELP
	set bat_vers=0.976

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	
	if /i "%~1" neq "" (
		if /i "%~2" neq "" (
			goto :SETUP
		)
	)

	goto :HELP
goto :SETUP

	
	
:SETUP
	set return=goto :EOF
	set bat_return=goto :EOF
	set BAT_ECHOLOG=call :ECHOLOG
	set BAT_LOG=call :LOG

	set bat_exedir=%~dp0::&						rem f:\CAMS\::
	set bat_exedir=!bat_exedir:\::=!&			rem f:\CAMS
	set bat_exedir=!bat_exedir:::=!&			rem f:\CAMS
	set bat_exedrive=!bat_exedir:~0,2!&			rem f:
	
	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
	set bat_logfile=!bat_startlocation!\MakeArchivedDateZip.bat.log
	
	
	%bat_echolog% =============================================================
	%bat_echolog% %date% %time% - %~dpnx0 %*
	
	set bat_returncode=0


	call :PARSEARGS %*
goto :MAIN

	
:MAIN
	call :MAKEZIP "!bat_targetdir!" "!bat_dirname!"

goto :DONE



:PARSEARGS
!bat_echolog! call :PARSEARGS %*
!bat_echolog! '     :PARSEARGS %1, %~dp1, %~nx1
	set bat_camera=%~1
	
	set bat_sourcedirname=%~2
	set bat_sourcedirbase=%~dp2::
	set bat_sourcedirbase=!bat_sourcedirbase:\::=!
	set bat_sourcedirbase=!bat_sourcedirbase:::=!
	
	set bat_captureddate=%~nx2
	
	set bat_targetdirname=%~3
!bat_echolog! return-:PARSEARGS [!bat_camera!, !bat_captureddate!, !bat_sourcedirname!, !bat_targetdirname!]
%return%



	rem 16. Make Transmit Zip *************************************
:MAKEZIP
!bat_echolog! call :MAKEZIP
	
	set bat_tempsrc=!bat_sourcedirname!
	set bat_tempdest=!bat_targetdirname!

	set bat_zipfile=!bat_targetdirname!\!bat_captureddate!.zip

:MZ_SEVENZIP

	if exist "!bat_zipfile!" (
		set /p bat_choice='!bat_zipfile!' already exists. Do you want to erase it and create a new one? 
		if /i "!bat_choice!" equ "n" goto :MAKEZIP_END
		if /i "!bat_choice!" neq "y" goto :MZ_SEVENZIP
	)
	
	call :SEVENZIP "!bat_tempsrc!" "!bat_tempdest!"
	
	if not exist "!bat_zipfile!" (
		!bat_echolog!     ERROR - Failed to create zip file: "!bat_zipfile!"
	) else (
		!bat_echolog!     SUCCESS - "!bat_zipfile!"
	)
:MAKEZIP_END
!bat_echolog! return-:MAKEZIPAUTO ["!bat_zipfile!"]
%bat_return%






:SEVENZIP
!bat_echolog! call :SEVENZIP
	!bat_echolog! '    call "!bat_exedir!\7za.exe" a -tzip "!bat_zipfile!" "!bat_tempsrc!"
	                   call "!bat_exedir!\7za.exe" a -tzip "!bat_zipfile!" "!bat_tempsrc!"
	set bat_retval=!errorlevel!
	set bat_retval=0
	if !bat_retval! neq 0 (
	!bat_echolog! '    ERROR - Failed to create the zip file...
	!bat_echolog! '    call "!bat_exedir!\7za.exe" a -tzip "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip" "!bat_tempsrc!\*.*" 
	!bat_echolog! '    errorlevel=!bat_retval!
	) else (
		if exist "!bat_zipfile!" (
			call :PURGESOURCEDIR
			!bat_echolog! '    move /y "!bat_sourcedirname!" "!bat_sourcedirname!"
			                   move /y "!bat_sourcedirname!" "!bat_sourcedirname!"
		) else (
			!bat_echolog! '    ERROR - Failed to create the zip file...
			!bat_echolog! '    call "!bat_exedir!\7za.exe" a -r -tzip "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip" "!bat_tempsrc!\*.*" 
			!bat_echolog! '    errorlevel=!bat_retval!
		)
	)
:SEVENZIP_END
!bat_echolog! return-:SEVENZIP [errorlevel=!bat_retval!]
%bat_return%


:PURGESOURCEDIR
!bat_echolog! call :PURGESOURCEDIR [%*]
	!bat_echolog! '    for /f "usebackq tokens=*" %%b in ^(`dir "!bat_sourcedirname!" /b /ad /on`^) do ^(
	for                    /f "usebackq tokens=*" %%b in (`dir "!bat_sourcedirname!" /s/b /ad /on`) do (
		!bat_echolog! '    for /f "usebackq tokens=*" %%c in ^(`dir "%%~b" /s/b /ad /on`^) do ^(
		for                    /f "usebackq tokens=*" %%c in (`dir "%%~b" /s/b /ad /on`) do (
			echo.%%c|find /i "MailFiles">nul:
			if !errorlevel! neq 0 (
				echo         del /s /q "%%~c"^&rd /s /q "%%~c"
							 del /s /q "%%~c"& rd /s /q "%%~c"
			) else (
				echo         Skipping removal of: "%%~c" ..........................
			)
		)
	)
!bat_echolog! return:PURGESOURCEDIR []
%bat_return%



:ECHOLOG
	rem Echo to the console and to the bat_logfile
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
	echo %bat_echolog_temp%
%bat_return%


:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%








:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 camera ^<"SourceDir"%^> [^<TargetDir^>]]
	echo.
	echo Creates a zip file of the specified directory using seven zip.
	echo.
	echo.
	echo Example:
	echo        %~nx0 299 "C:\CAMS\SubmissionFiles\2012_03_01"
	echo.
	echo Another example to process all the dates in September, 2011:
	echo     for /f "usebackq tokens=*" %%a in ^(`dir "D:\CAMS\SubmissionFiles\2011_09_*" /b /ad /on`^) do ^(call "makearchivedatezip.bat" 213 "d:\cams\SubmissionFiles\%%~a" "d:\cams\SubmissionFiles"^)
exit /b 9



:DONE
	echo.
	echo Done with %0 %*
	echo.
