 @echo off
setlocal enableextensions enabledelayedexpansion

echo ============================================================
echo %~0 %*
echo.

:CHECKHELP
	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP


	set bat_autonomous=
	echo.%*|find /i "autonomous">nul:
	if %errorlevel% equ 0 (
		set bat_autonomous=autonomous
	)

	if not defined bat_autonomous (
		echo Running in normal [non-autonomous] mode
	) else (
		echo Running in autonomous mode
	)
goto :SETUP

	Flowchart:
		- list all the email files under the SubmissionFiles directory tree
		- Copy all those "emailfiles\*.*" files to ".\cams\temp"
		- zip the files up into a single zip file

J:\CAMS\SubmissionFiles\2011_08_03_06_58_10\EmailFiles
J:\CAMS\SubmissionFiles\2011_08_03_06_58_10\EmailFiles\CAL212_20110807_051341_380.txt
J:\CAMS\SubmissionFiles\2011_08_03_06_58_10\EmailFiles\CAL213_20110803_065814_645.txt
J:\CAMS\SubmissionFiles\2011_08_03_06_58_10\EmailFiles\CAL213_20110804_060415_300.txt
J:\CAMS\SubmissionFiles\2011_08_03_06_58_10\EmailFiles\CAL213_20110805_044049_109.txt
J:\CAMS\SubmissionFiles\2011_08_03_06_58_10\EmailFiles\CAL213_20110806_074504_223.txt
J:\CAMS\SubmissionFiles\2011_08_03_06_58_10\EmailFiles\CAL213_20110815_042825_117.txt
J:\CAMS\SubmissionFiles\2011_08_03_06_58_10\EmailFiles\CAL213_20110816_040057_853.txt

:SETUP
	set return=goto :EOF
	
	set bat_startlocation=%cd%
	set bat_startdrive=%cd:~0,2%
	set bat_caldir=%bat_startlocation%\Cal
	set bat_logfile=%0.log

:MAIN
	rem start the execution of the detection pass in background priority

	echo %date% %time%: %~0 %*>"%bat_logfile%"
	set bat_>>"%bat_logfile%"
	
	call :PARSEARGS %*
	
	call :GETDIRNAMES
goto :DONE


:PARSEARGS
	echo :PARSEARGS %~1, %~dp1, %~nx1
	set bat_dirdate=%~1
	set bat_dirdate=!bat_dirdate:~0,10!
	set bat_mainfilter= 
	if "%~1" neq "" (
		set bat_mainfilter=^|find /i "!bat_dirdate!"
	)
	
	if "%~2" neq "" (
		set bat_camera=%~2
	) else (
		set /p bat_camera=Enter Camera number: 
	)
	
	echo    bat_camera=!bat_camera!
	echo    bat_dirdate=!bat_dirdate!
	echo    bat_mainfilter=!bat_mainfilter!
echo return-:PARSEARGS [!bat_camera!, !bat_dirdate!, !bat_mainfilter!]
%return%

:GETDIRNAMES
echo call :GETDIRNAMES
echo call :GETDIRNAMES>>"%bat_logfile%"
	rem Loop to iterate through all directory names under the ".\SubmissionFiles\[date/time]\EmailFiles".
	rem Then, extract the [date/time] and use that as the target dir for the copy
	rem Note: possibly use the following command instead of `dir /ad /s/b`:
	rem    forfiles /p ".\SubmissionFiles" /m "emailfiles" /s /c "cmd /c echo @path"
	rem or, we could use the /d option to include only those directories that have a 
	rem Modified Date within the last -n days
	rem    forfiles /p ".\SubmissionFiles" /m "emailfiles" /s /c "cmd /c echo @path" /d -7

	set bat_loop=continue
	for /f "usebackq tokens=*" %%a in (`dir "SubmissionFiles\!bat_dirdate!\!bat_camera!\EmailFiles" /ad /s/b /on !bat_mainfilter!`) do (
		if /i "!bat_loop!" equ "continue" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					echo.
					echo.
					echo.>>"%bat_logfile%"
					echo    ........................................
					echo    ........................................>>"%bat_logfile%"
					echo    a=%%a
					set bat_temp=%%a
					set bat_emailfilesdir=%%~dpa::
					set bat_emailfilesdir=!bat_emailfilesdir:\::=!
					set bat_emailfilesdir=!bat_emailfilesdir:::=!

					set bat_temp=!bat_emailfilesdir!

					call :GETDATEDIR "%%~a" "!bat_emailfilesdir!"

					set bat_targetdir=!bat_startlocation!\Submitted\!bat_dirdate!_!bat_camera!\!bat_camera!
					set bat_targetbasedir=!bat_startlocation!\Submitted\!bat_dirdate!_!bat_camera!
					echo     bat_targetdir=!bat_targetdir!


					if "!bat_targetdir!" equ "" (
						call :GETDIRERROR
						set bat_loop=break
					)


					rem Read the detect file (if confirmed doesn't exist, then
					rem use archived) to get FFdir, caldr, meteorcount, 
					rem cal dir, and cal name. 
					call :READFILE

					echo.
					echo     robocopy.exe "!bat_basedir!\EmailFiles" "!bat_targetdir!\EmailFiles" "*.*" /s /e /copyall
							 robocopy.exe "!bat_basedir!\EmailFiles" "!bat_targetdir!\EmailFiles" "*.*" /s /e /copyall

					echo.
					echo     robocopy.exe "!bat_basedir!\ArchivedFiles" "!bat_targetdir!\ArchivedFiles" "*.txt" /s /e /copyall
							 robocopy.exe "!bat_basedir!\ArchivedFiles" "!bat_targetdir!\ArchivedFiles" "*.txt" /s /e /copyall
					call :DELUNWANTED "!bat_targetdir!\ArchivedFiles"


					echo.
					echo     robocopy.exe "!bat_basedir!\Cal" "!bat_targetdir!\Cal" "*.txt" /s /e /copyall
							 robocopy.exe "!bat_basedir!\Cal" "!bat_targetdir!\Cal" "*.txt" /s /e /copyall
					call :DELUNWANTED "!bat_targetdir!\Cal"

					echo.
					echo     robocopy.exe "!bat_basedir!\CapturedFiles" "!bat_targetdir!\CapturedFiles" "*.txt" /s /e /copyall
							 robocopy.exe "!bat_basedir!\CapturedFiles" "!bat_targetdir!\CapturedFiles" "*.txt" /s /e /copyall
					call :DELUNWANTED "!bat_targetdir!\CapturedFiles"


					echo.
					echo     robocopy.exe "!bat_basedir!\ConfirmedFiles" "!bat_targetdir!\ConfirmedFiles" "*.txt" /s /e /copyall
							 robocopy.exe "!bat_basedir!\ConfirmedFiles" "!bat_targetdir!\ConfirmedFiles" "*.txt" /s /e /copyall
					call :DELUNWANTED "!bat_targetdir!\ConfirmedFiles"


					echo del 
					set bat_>>"!bat_logfile!"
					echo.
					echo =====================================
					echo.
				)&rem if /i "%%~nxa" neq "gefdat"...
			)&rem if /i "%%~nxa"..."displayJPEGS"...
		)&rem if /i "!bat_loop!"...
	)&rem for

echo return-:GETDIRNAMES [!bat_emailfilesdir!]
%return%




:READFILE
echo call :READFILE
	rem Loop to read the FTPdetectinfo.txt file.

	set bat_readfile=!bat_emailfilesdir!\FTPdetectinfo_confirmed-!bat_camera!.txt
	
	if not exist "!bat_readfile!" (
		set bat_readfile=!bat_emailfilesdir!\FTPdetectinfo_scanned-!bat_camera!.txt
	)

	if not exist "!bat_readfile!" (
		echo [:READFILE] "!bat_readfile!" does not exist>>"!bat_logfile!"
		if not exist "!bat_readfile!" (
			echo     ERROR - Cannot continue without a detect file:
			echo             "!bat_readfile!"
			echo.
			echo     The files have already been moved... you will need to move 
			echo     them back and start over after resolving the problems.
			echo.
			set bat_retval=failed
			echo     [:READFILE]     ERROR - "!bat_readfile!" does not exist>>"!bat_logfile!"
			exit /b
		)
	)


	set bat_msg= 
	set /a bat_linecount=0
	set /a bat_filecount=0
	echo '    for /f "usebackq tokens=*" ..a in ^(`type "!bat_readfile!"`^) do ...
	for           /f "usebackq tokens=*" %%a in  (`type "!bat_readfile!"`) do (
		set bat_temp=%%a
		set bat_temp=!bat_temp:~0,5!
		rem title bat_linecount=!bat_linecount! %%a
		set /a bat_linecount+=1
		if !bat_linecount! equ 1 (
			call :GETMETEORCOUNT %%a
		) else (
			if !bat_linecount! equ 5 (
				call :GETFFDIR "%%a"
			) else (
				if !bat_linecount! equ 6 (
					rem call :GETCALDIR "%%a"
				) else (
					if !bat_linecount! equ 13 (
						call :GETCAMERA
						set bat_fffilename=%%a
						title !bat_fffilename!
					) else (
						if !bat_linecount! equ 14 (
							call :GETCALNAME "%%a"
						) else (
							if "!bat_temp!" equ "FF!bat_camera!" (
								set bat_fffilename=%%a
								title working on FF file: "!bat_fffilename!"
								set /a bat_filecount+=1
							)
						)
					)
				)
			)
		)
	)
echo return-:READFILE: 
%return%



:GETDATEDIR
echo call :GETDATEDIR [%*] %~1, %~dp1, %~nx1
	rem set bat_basedir=!bat_startlocation!\SubmissionFiles\!bat_dirdate!\!bat_camera!
	set bat_basedir=%~dp2::
	set bat_basedir=!bat_basedir:\::=!
	set bat_basedir=!bat_basedir:::=!
echo return-:GETDATEDIR bat_basedir=!bat_basedir!
%return%



:GETMETEORCOUNT
echo call :GETMETEORCOUNT %1, %2, %3, %4
	rem Usage: call :GETMETEORCOUNT Meteor Count = 000533

	set bat_temp=%3
	if "!bat_temp!" equ "000000" (
		set bat_msg=; needs FTP_Reprocess
	)

	for /f "tokens=* delims=0" %%a in ("!bat_temp!") do (set bat_countconfirmed=%%a)
	if not defined bat_countconfirmed set bat_countconfirmed=0
echo return-:GETMETEORCOUNT: [bat_countconfirmed=!bat_countconfirmed!]
%return%	




:GETFFDIR
echo call :GETFFDIR %*
	rem Usage: call :GETFFDIR "FF  folder = c:\CAMS\ArchivedFiles\2011_08_05_04_40_44\"
	rem Called when reaing FTPdetectinfo.txt line 5 to fetch the FF folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d
		set bat_ffdir=!bat_temp2:C:=%bat_startdrive%!
	)
echo return-:GETFFDIR [!bat_ffdir!]
%return%

:GETCALDIR
echo call :GETCALDIR %*
	rem Usage: call :GETCALDIR "CAL folder = c:\CAMS\Cal\"
	rem Called when reaing FTPdetectinfo.txt line 6 to fetch the Cal folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d
		set bat_caldir=!bat_temp2:C:=%bat_startdrive%!
	)
echo return-:GETCALDIR [!bat_caldir!]
%return%


	rem 
:GETCALNAME
	set bat_calfilename=%~1
%return%


:COPYCALFILE
	echo     copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_emailfilesdir!"
	copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_emailfilesdir!"
%return%

:GETCAMERA
	set bat_camera=!bat_temp:~2,3!
%return%



:STRIPARCHHEADER
	rem Strips the header from the FTPdetectinfo_scanned-!bat_camera!.txt file.  
	rem The camera number and the meteor count are added to the 
	rem filename as follows:
	rem   FTPdetectinfo_scanned-[camera]-[meteor count].txt
	
%return%

:STRIPCONFHEADER
	rem Strips the header from the FTPdetectinfo_confirmed-!bat_camera!.txt file found
	rem in the ConfirmedFiles directory.  The camera number and 
	rem the meteor count are added to the filename as follows:
	rem   FTPdetectinfo_confirmed-[camera]-[meteor count].txt
	
%return%


:GETDIRERROR
	echo.
	echo     ERROR - one of these settings is bad:
	set bat_
%return%


:DELUNWANTED
echo call :DELUNWANTED %*
	echo for /f "usebackq tokens=*" %%a in ^(`dir "%~1" /s/b /ad`^) do ^(
	for      /f "usebackq tokens=*" %%a in  (`dir "%~1" /s/b /ad`) do (
		set bat_unwanteddir=%%~a
		set bat_unwanteddirname=%%~nxa
		echo     Cleaning "!bat_unwanteddir!"

		if "!bat_unwanteddirname!" equ "displayJPEGs" (
			echo     del /f /s /q "!bat_unwanteddir!\*.*"
			         del /f /s /q "!bat_unwanteddir!\*.*"
			echo     rd /s /q "!bat_unwanteddir!"
			         rd /s /q "!bat_unwanteddir!"
		)

		if "!bat_unwanteddirname!" equ "gefdat" (
			echo     del /f /s /q "!bat_unwanteddir!\*.*"
			         del /f /s /q "!bat_unwanteddir!\*.*"
			echo     rd /s /q "!bat_unwanteddir!"
			         rd /s /q "!bat_unwanteddir!"
		)

		if "!bat_unwanteddirname!" equ "movies" (
			echo     del /f /s /q "!bat_unwanteddir!\*.*"
			         del /f /s /q "!bat_unwanteddir!\*.*"
			echo     rd /s /q "!bat_unwanteddir!"
			         rd /s /q "!bat_unwanteddir!"
		)

		if exist "!bat_unwanteddir!\FFCorruptFilesLog*.*" (
			del /q /f "!bat_unwanteddir!\FFCorruptFilesLog*.*"
		)
		if exist "!bat_unwanteddir!\FTPdetectinfo_Case*.*" (
			del /q /f "!bat_unwanteddir!\FTPdetectinfo_Case*.*"
		)
		if exist "!bat_unwanteddir!\FFdirectorylisting_*.*" (
			del /q /f "!bat_unwanteddir!\FFdirectorylisting_*.*"
		)
	)
echo return-:DELUNWANTED %*
%return%




:CONTINUE
	@echo     start "FTP_Reprocess" /low ".\ftp_reprocess.exe" ".\CapturedFiles\%ftp_captureddir%">>"bat_logfile!"
	echo      start "FTP_Reprocess" /low ".\ftp_reprocess.exe" ".\CapturedFiles\%ftp_captureddir%"
goto :DONE


:ERR1
	@echo.
	@echo.
	@echo     "%cd%\ArchivedFiles\%ftp_archiveddir%" already exists. Do you want to
	@echo     continue to overwrite the existing files? [Y/N] Y
	@goto :CONTINUE
	if not defined bat_autonomous (
		@set /p retval=continue to overwrite the existing files? [Y/N] 
		@if /i "%retval%" equ "y" goto :CONTINUE
	)
exit /b 1
goto :DONE



:CREATEDIRS
echo call :CREATEDIRS %*
	rem usage: call :CREATEDIRS "!bat_dirname!"
	rem Creates the target dirs that it can, but some have to be done
	rem in the loop while reading the ftpdetectinfo.txt file
	echo     md "!bat_targetdir!"
		     md "!bat_targetdir!"
	echo     md "!bat_targetdir!\Cal-!bat_camera!"
		     md "!bat_targetdir!\Cal-!bat_camera!"
echo return-:CREATEDIRS [!bat_targetdir!]
%return%
	
:MOVEFILES

%return%


:MOVEERROR
%return%



:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	setlocal
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	set "yy=%~2"&set "mm=%~3"&set "dd=%~4"
	set /a "yy=10000%yy% %%10000,mm=100%mm% %% 100,dd=100%dd% %% 100"
	if %yy% LSS 100 set /a yy+=2000 &rem Adds 2000 to two digit years
	set /a JD=dd-32075+1461*(yy+4800+(mm-14)/12)/4+367*(mm-2-(mm-14)/12*12)/12-3*((yy+4900+(mm-14)/12)/100)/4
	ENDLOCAL & IF "%~1" NEQ "" (SET %~1=%JD%) ELSE (echo.%JD%)
EXIT /b

:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	SETLOCAL ENABLEDELAYEDEXPANSION
	set /a L= %~1+68569,     N= 4*L/146097, L= L-(146097*N+3)/4, I= 4000*(L+1)/1461001
	set /a L= L-1461*I/4+31, J= 80*L/2447,  K= L-2447*J/80,      L= J/11
	set /a J= J+2-12*L,      I= 100*(N-49)+I+L
	set /a YYYY= I,  MM=100+J,  DD=100+K
	set MM=%MM:~-2%
	set DD=%DD:~-2%
	( ENDLOCAL & REM RETURN VALUES
	    IF "%~2" NEQ "" (SET %~2=%YYYY%) ELSE echo.%YYYY%
	    IF "%~3" NEQ "" (SET %~3=%MM%) ELSE echo.%MM%
	    IF "%~4" NEQ "" (SET %~4=%DD%) ELSE echo.%DD%
	)
EXIT /b



:GETCAMERAFROMDETECT
echo call :GETCAMERAFROMDETECT [%*]
	
	for /f "usebackq tokens=*" %%b in (`dir "submissionfiles\!bat_dirdate!\ftpdetectinfo_scanned-!bat_camera!.txt" /s/b /a-d|find /i "emailfiles"`) do (
		set bat_detectfile1=%%dpnxb
	)
	
	echo return-:GETCAMERAFROMDETECT: [%*]   [camera=!bat_camera!] [!bat_detectfile1!]
	if "!bat_camera!" equ "" (
		echo     ERROR: couldn't determine camera number
		if not defined bat_autonomous (
			pause
		)
	)
echo return-:GETCAMERAFROMDETECT: [%*] [camera=!bat_camera!]  []
%return%
			
			
			
:HELP
	@echo off
	echo.
	echo %0
	echo.
	echo Usage: %0
	echo.
	echo This script can be run stand-alone (before reprocessing) or called from within
	echo a script.
	echo.
	echo The purpose of this script is to copy the ".\SubmissionFiles\[date]\EmailFiles\" 
	echo into the ".\Submitted\[date]" directory tree.  What you'll have left is a bunch of 
	echo directories (dates of captured/processed/confirmed files).
	echo.
	echo The organization of the target files will be as follows:
	echo 	.\cams\SubmissionFiles\2011_08_01_05_00_19\EmailFiles       contains:
	echo 		- FTPdetectinfo.txt			renamed to FTPdetectinfo_213_2011_08_01_05_00_19_confirmed.txt
	echo 							This is the one from the \cams\ConfirmedFiles directory.
	echo 							Also, it should be patched to reflect where  
	echo 							the ff*.bin files are, relative from the 
	echo 							current dir
	echo 		- FTPdetectinfo.txt			renamed to FTPdetectinfo_213_2011_08_01_05_00_19_scanned.txt
	echo 							This is the one from the \cams\ArchivedFiles directory.
	echo 							Also, it should be patched to reflect where  
	echo 							the ff*.bin files are, relative from the 
	echo 							current dir
	echo 		- CameraTimeOffsets.txt			renamed to CameraTimeOffsets_Brentwood_2011_08_01_05_00_19.txt
	echo 		- LASTSETTINGS.txt			renamed to LASTSETTINGS_Brentwood_2011_08_01_05_00_19.txt
	echo 		- ReprocessParameters.txt		renamed to ReprocessParameters_Brentwood_2011_08_01_05_00_19.txt
	echo 		- \cams\cal\CameraSites.txt		renamed to CameraSites_Brentwood_2011_08_01.txt
	echo 		- \cams\cal\CAL213_20110801_050019_514.txt
	echo.				 
	echo 	.\cams\SubmissionFiles\2011_08_01_05_00_19\BinFiles
	echo 		- contains the FF*.bin files
	echo 	.\cams\SubmissionFiles\2011_08_01_05_00_19\AviFiles
	echo.
	echo After the script verifies the movement of all these files, it is ready to create a
	echo zip file of everything in the ".\SubmissionFiles\<datetime>\EmailFiles" so that 
	echo they can be sent via email.
	echo.
	echo Most of this can be automated in this script in batch mode. We can't make a 
	echo DVD unattended though and that will need to be done manually.
	echo.
	echo To make the DVD, we copy ".\cams\SubmissionFiles\*.*" to the DVD burner.
	echo It might work better with RoboCopy, since I think it might support filling
	echo up a DVD and then continuing, but I'm not quite sure.
	echo.
	echo Once the DVD is burned, the files should be moved to ".\cams\SubmittedFiles\..." 
	echo.
	echo After a period of time, the specific ".\cams\SubmittedFiles\<datetime> directories can 
	echo be purged from the hard drive to make room for newer files. 
	echo.
	echo Ideally, all this should run from a copy on an external hard drive 
	echo so it can be processed on another computer and it won't interfere with capture, etc.
	echo.
	echo One issue to resolve is when there is an ArchivedFiles\^<date/time^> directory but no 
	echo matching ConfirmedFiles^<date/time^> directory.  This could have been caused by
	echo not being able to complete the processing due to some bug or corrupt files.  In that
	echo case, we just submit the files from the ArchivedFiles\^<date/time^> directory and 
	echo notate that in the readme.txt file in the directory.
	echo.
	echo Also, we need to start copying the necessary CAL and other files into the ArchivedFiles 
	echo directory as part of the ftp_reprocess.bat steps.  Perhaps we do that by calling
	echo a "complete_reprocessing.bat" routine.  Such a routine should be able to be run at
	echo anytime after FTP_Reprocess.exe is completed (or even while it is running).
	echo.
exit /b 9


:DONE
	echo.
	echo Done with %0 %*
	echo.
